# README

[![PyPI version](https://img.shields.io/pypi/v/git-rg)](https://pypi.org/project/git-rg/)
[![Downloads](https://img.shields.io/pypi/dm/git-rg)](https://pypi.org/project/git-rg/)

`git-rg` is a command-line tool for recursively searching for files in Git repositories that contain specific text patterns using regular expressions. It's useful for finding sensitive information like accidentally committed passwords or API keys within `.git` directories.

## Installation

```bash
pipx install git-rg
```

To install latest version from Github:

```bash
pipx install git+https://github.com/s3rgeym/git-rg
```

## Usage

```bash
git-rg <pattern> [path] [-B <num>] [-A <num>]
```

### Arguments

- `pattern`: Regular expression to search for.
- `path`: Path to the directory where the search should begin (default: current directory).
- `-B`, `--before`: Number of lines to show before the match.
- `-A`, `--after`: Number of lines to show after the match.

### Example

To search for passwords in all `.git` files within the current directory and show 2 lines before and after the match:

```bash
git-rg "(?i)password\s*=\s*['\"]?(\w+)['\"]?" ~/projects -B 2 -A 2
```

![image](https://github.com/user-attachments/assets/284cd05e-d635-4530-8324-1661361c69c5)
